apiVersion: kyverno.io/v1
kind: ClusterPolicy
metadata:
  name: restrict-apparmor
  annotations:
    policies.opencode.de/ID: tbd
    policies.opencode.de/bsi-requirement: tbd
    policies.kyverno.io/category: Pod Security Standards (Baseline)
    policies.kyverno.io/severity: medium
    policies.kyverno.io/subject: Pod, Annotation
    policies.kyverno.io/minversion: 1.3.0
    policies.kyverno.io/description: >-
      On supported hosts, the 'runtime/default' AppArmor profile is applied by default. 
      The default policy should prevent overriding or disabling the policy, or restrict 
      overrides to an allowed set of profiles. This policy ensures Pods do not
      specify any other AppArmor profiles than `runtime/default`.
  labels:
    policies.opencode.de/bsi-protection-requirement: standard
    policies.opencode.de/category: should
spec:
  validationFailureAction: audit
  background: true
  rules:
    - name: app-armor
      match:
        resources:
          kinds:
            - Pod
      validate:
        message: >-
          Specifying other AppArmor profiles is disallowed. The annotation
          container.apparmor.security.beta.kubernetes.io must not be defined,
          or must not be set to anything other than `runtime/default`.          
        pattern:
          metadata:
            =(annotations):
              =(container.apparmor.security.beta.kubernetes.io/*): "runtime/default"
